
extern string h6 = "---MACD-----------------";

extern int MACD_Fast   = 12;
extern int MACD_Slow   = 26;
extern int MACD_Signal = 9;

extern string  ___         = "---------------- Money Management";
extern double  Lots        = 0.1;
extern double  RiskPercent = 3;


extern double tp = 120;
extern double sl = 60;
static int sdelka = 0;




 string tpr = "";
// StopLoss level
extern int       MagicNumber   = 777;
static int prevtime = 0;
static int spread   = 3;


int k=1;





int init() {
       if (Digits==3 || Digits==5) k=10;
       tp =  tp*k;
       sl =  sl*k;
       return(0);
}


int deinit()
   {

   }
//************************************************************************************************
int start()
  {

   if (Time[0] == prevtime) return(0);
   prevtime = Time[0];
   spread = MarketInfo(Symbol(), MODE_SPREAD);
   int i = 0;
   

   int  total = OrdersHistoryTotal();   
   for (i = 0; i < total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_HISTORY); 
      // check for symbol & magic number
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {         
         // change type
         if (OrderType() == OP_BUY  && OrderProfit()<0) {
            sdelka = 1;
         } 
         if (OrderType() == OP_SELL && OrderProfit()<0) {
            sdelka = -1;
         }
      }
   }
 if (sdelka != -1 &&  retOrders(Symbol())== 0    && TradingSystem()<0) 
                     {OrderSend(Symbol(),OP_SELL,GetLots(Symbol()), Bid, 3, Ask + sl * Point, Bid - tp * Point, "", MagicNumber, 0, Red); }
 if (sdelka !=  1 &&  retOrders(Symbol())== 0    && TradingSystem()>0)
                     {OrderSend(Symbol(),OP_BUY, GetLots(Symbol()), Ask, 3, Bid - sl * Point, Bid + tp * Point, "", MagicNumber, 0, Blue);}
           
 }

//************************************************************************************************
//  
//************************************************************************************************
double GetLots(string _Symbol) {
  if(IsOptimization())return(0.1);
   double RetVal;
   double LotsMin    = MarketInfo(_Symbol,MODE_MINLOT);
   double LotsMax    = MarketInfo(_Symbol,MODE_MAXLOT);
   double LotsStep   = MarketInfo(_Symbol,MODE_LOTSTEP);
   RetVal=MathCeil(Lots/LotsStep)*LotsStep;
   if (RiskPercent>0) 
      RetVal=MathCeil(AccountFreeMargin()/100000*RiskPercent/LotsStep)*LotsStep;
   RetVal=MathMin(LotsMax,MathMax(LotsMin,RetVal));
   return(RetVal);
}
//************************************************************************************************
int retOrders(string sym){
   int total = OrdersTotal();
   int OrderCount=0;
   for(int i = 0; i <= total; i++) 
     {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if( OrderMagicNumber() == MagicNumber && OrderSymbol() == sym) 
         {
          if(OrderType()==OP_BUY)return(1);
          if(OrderType()==OP_SELL)return(-1);
         }
      }
     return(0);
 }
//************************************************************************************************  
double TradingSystem() {
    return(iMACD(NULL,0,MACD_Fast,MACD_Slow,MACD_Signal,PRICE_OPEN,MODE_MAIN,     0));
 }
//************************************************************************************************

